
module dwt.internal.mozilla.nsXPCOM;

import dwt.internal.mozilla.Common;
import dwt.internal.mozilla.nsStringAPI;
import dwt.internal.mozilla.nsIModule;
import dwt.internal.mozilla.nsIComponentManager;
import dwt.internal.mozilla.nsIComponentRegistrar;
import dwt.internal.mozilla.nsIServiceManager;
import dwt.internal.mozilla.nsIFile;
import dwt.internal.mozilla.nsILocalFile;
import dwt.internal.mozilla.nsIDirectoryService;
import dwt.internal.mozilla.nsIMemory;
import dwt.internal.mozilla.nsIDebug;
import dwt.internal.mozilla.nsITraceRefcnt;

/******************************************************************************

******************************************************************************/

extern (System):

struct nsStaticModuleInfo
{
    char *name;
    nsGetModuleProc getModule;
}

alias nsresult function (nsIComponentManager, nsIFile, nsIModule*) nsGetModuleProc;

/******************************************************************************

******************************************************************************/

nsresult  NS_InitXPCOM2( nsIServiceManager *result, nsIFile binDirectory,
	                     nsIDirectoryServiceProvider appFileLocationProvider );
nsresult  NS_InitXPCOM3( nsIServiceManager *result, nsIFile binDirectory,
	                     nsIDirectoryServiceProvider appFileLocationProvider,
	                     nsStaticModuleInfo* staticComponents,
	                     PRUint32 componentCount );

nsresult  NS_ShutdownXPCOM(nsIServiceManager servMgr);
nsresult  NS_GetServiceManager(nsIServiceManager *result);
nsresult  NS_GetComponentManager(nsIComponentManager *result);
nsresult  NS_GetComponentRegistrar(nsIComponentRegistrar *result);
nsresult  NS_GetMemoryManager(nsIMemory *result);
nsresult  NS_NewLocalFile(nsAString* path, PRBool followLinks, nsILocalFile* result);
nsresult  NS_NewNativeLocalFile(nsACString* path, PRBool followLinks, nsILocalFile* result);
void *    NS_Alloc(PRSize size);
void *    NS_Realloc(void *ptr, PRSize size);
void      NS_Free(void *ptr);
nsresult  NS_GetDebug(nsIDebug *result);
nsresult  NS_GetTraceRefcnt(nsITraceRefcnt *result);
